/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the WebhookEventMessage type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventMessage{}

// WebhookEventMessage struct for WebhookEventMessage
type WebhookEventMessage struct {
	Id string `json:"id"`
	AuthorId *string `json:"author_id,omitempty"`
	Type MessageType `json:"type"`
	Direction string `json:"direction"`
	Text *string `json:"text,omitempty"`
	Source *string `json:"source,omitempty"`
	ReplyToId *string `json:"reply_to_id,omitempty"`
	Labels []string `json:"labels,omitempty"`
	Data *WebhookEventMessageData `json:"data,omitempty"`
	Timestamp time.Time `json:"timestamp"`
}

// NewWebhookEventMessage instantiates a new WebhookEventMessage object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventMessage(id string, type_ MessageType, direction string, timestamp time.Time) *WebhookEventMessage {
	this := WebhookEventMessage{}
	this.Id = id
	this.Type = type_
	this.Direction = direction
	this.Timestamp = timestamp
	return &this
}

// NewWebhookEventMessageWithDefaults instantiates a new WebhookEventMessage object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventMessageWithDefaults() *WebhookEventMessage {
	this := WebhookEventMessage{}
	return &this
}

// GetId returns the Id field value
func (o *WebhookEventMessage) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WebhookEventMessage) SetId(v string) {
	o.Id = v
}

// GetAuthorId returns the AuthorId field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetAuthorId() string {
	if o == nil || IsNil(o.AuthorId) {
		var ret string
		return ret
	}
	return *o.AuthorId
}

// GetAuthorIdOk returns a tuple with the AuthorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetAuthorIdOk() (*string, bool) {
	if o == nil || IsNil(o.AuthorId) {
		return nil, false
	}
	return o.AuthorId, true
}

// HasAuthorId returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasAuthorId() bool {
	if o != nil && !IsNil(o.AuthorId) {
		return true
	}

	return false
}

// SetAuthorId gets a reference to the given string and assigns it to the AuthorId field.
func (o *WebhookEventMessage) SetAuthorId(v string) {
	o.AuthorId = &v
}

// GetType returns the Type field value
func (o *WebhookEventMessage) GetType() MessageType {
	if o == nil {
		var ret MessageType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetTypeOk() (*MessageType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WebhookEventMessage) SetType(v MessageType) {
	o.Type = v
}

// GetDirection returns the Direction field value
func (o *WebhookEventMessage) GetDirection() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Direction
}

// GetDirectionOk returns a tuple with the Direction field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetDirectionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Direction, true
}

// SetDirection sets field value
func (o *WebhookEventMessage) SetDirection(v string) {
	o.Direction = v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *WebhookEventMessage) SetText(v string) {
	o.Text = &v
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *WebhookEventMessage) SetSource(v string) {
	o.Source = &v
}

// GetReplyToId returns the ReplyToId field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetReplyToId() string {
	if o == nil || IsNil(o.ReplyToId) {
		var ret string
		return ret
	}
	return *o.ReplyToId
}

// GetReplyToIdOk returns a tuple with the ReplyToId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetReplyToIdOk() (*string, bool) {
	if o == nil || IsNil(o.ReplyToId) {
		return nil, false
	}
	return o.ReplyToId, true
}

// HasReplyToId returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasReplyToId() bool {
	if o != nil && !IsNil(o.ReplyToId) {
		return true
	}

	return false
}

// SetReplyToId gets a reference to the given string and assigns it to the ReplyToId field.
func (o *WebhookEventMessage) SetReplyToId(v string) {
	o.ReplyToId = &v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *WebhookEventMessage) SetLabels(v []string) {
	o.Labels = v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *WebhookEventMessage) GetData() WebhookEventMessageData {
	if o == nil || IsNil(o.Data) {
		var ret WebhookEventMessageData
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetDataOk() (*WebhookEventMessageData, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *WebhookEventMessage) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given WebhookEventMessageData and assigns it to the Data field.
func (o *WebhookEventMessage) SetData(v WebhookEventMessageData) {
	o.Data = &v
}

// GetTimestamp returns the Timestamp field value
func (o *WebhookEventMessage) GetTimestamp() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessage) GetTimestampOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Timestamp, true
}

// SetTimestamp sets field value
func (o *WebhookEventMessage) SetTimestamp(v time.Time) {
	o.Timestamp = v
}

func (o WebhookEventMessage) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventMessage) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	if !IsNil(o.AuthorId) {
		toSerialize["author_id"] = o.AuthorId
	}
	toSerialize["type"] = o.Type
	toSerialize["direction"] = o.Direction
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.ReplyToId) {
		toSerialize["reply_to_id"] = o.ReplyToId
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	toSerialize["timestamp"] = o.Timestamp
	return toSerialize, nil
}

type NullableWebhookEventMessage struct {
	value *WebhookEventMessage
	isSet bool
}

func (v NullableWebhookEventMessage) Get() *WebhookEventMessage {
	return v.value
}

func (v *NullableWebhookEventMessage) Set(val *WebhookEventMessage) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventMessage) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventMessage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventMessage(val *WebhookEventMessage) *NullableWebhookEventMessage {
	return &NullableWebhookEventMessage{value: val, isSet: true}
}

func (v NullableWebhookEventMessage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventMessage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


